summaryrefslogtreecommitdiff
diff options
context:
space:
mode:
authorGerardo Exequiel Pozzi <vmlinuz386@yahoo.com.ar>2011-12-03 17:45:45 -0300
committerGerardo Exequiel Pozzi <vmlinuz386@yahoo.com.ar>2011-12-03 17:45:45 -0300
commit92dbba6c110a39bec4654415c9957e173fdec28a (patch)
treec9d05de89e87edae5df0b5ad774e88574314e974
parent305bca4692ed9741a425a8c77f81ef50aaa8fc39 (diff)
[archiso] Cleanup: pxe_curl: Remove download-iso-loopback support.
This was the first implementation that downloads the complete ISO, but now we have the posibility of download only needed *.sfs files. Signed-off-by: Gerardo Exequiel Pozzi <vmlinuz386@yahoo.com.ar>
-rw-r--r--README7
-rw-r--r--archiso/hooks/archiso_pxe_curl54
2 files changed, 22 insertions, 39 deletions
diff --git a/README b/README
index 9de113d..c8f7331 100644
--- a/README
+++ b/README
@@ -89,10 +89,9 @@ INDEX
** hooks/archiso_pxe_curl
-* archiso_curl_url= Set an HTTP/FTP URL of an ISO file (first form),
- or a path (must end with /) where ${archisobasedir}
- is found with all *.sfs files (second form).
- In the IP part if ${pxeserver} is used, PXE IP will be used.
+* archiso_curl_url= Set an HTTP/FTP URL (must end with /) where ${archisobasedir}
+ is found with all *.sfs files.
+ In the IP/domain part if ${pxeserver} is used, use PXE IP.
Default: (unset)
* curlspace_size= Set the size of tmpfs of "curlspace" where the specified
ISO image or *.sfs files are downloaded.
diff --git a/archiso/hooks/archiso_pxe_curl b/archiso/hooks/archiso_pxe_curl
index 858bacb..8f3711c 100644
--- a/archiso/hooks/archiso_pxe_curl
+++ b/archiso/hooks/archiso_pxe_curl
@@ -13,13 +13,13 @@ run_hook() {
# Fetch a file with CURL
#
# $1 URL
-# $2 Destination directory inside curlspace
+# $2 Destination directory inside curlspace/${archisobasedir}
_curl_get() {
local _url="${1}"
local _dst="${2}"
msg ":: Downloading '${_url}'"
- if ! curl -f -o "/run/archiso/curlspace/${_dst}/${_url##*/}" --create-dirs "${_url}"; then
+ if ! curl -f -o "/run/archiso/curlspace/${archisobasedir}${_dst}/${_url##*/}" --create-dirs "${_url}"; then
echo "ERROR: Downloading '${_url}'"
echo " Falling back to interactive prompt"
echo " You can try to fix the problem manually, log out when you are finished"
@@ -34,44 +34,28 @@ archiso_pxe_curl_mount_handler () {
mkdir -p "/run/archiso/curlspace"
mount -t tmpfs -o size="${curlspace_size}",mode=0755 curlspace "/run/archiso/curlspace"
- # Check if URL ends in /
- if [[ "${archiso_curl_url}" != "${archiso_curl_url%/}" ]]; then
+ local _aitab_url="${archiso_curl_url}${aitab#/run/archiso/bootmnt/}"
+ local _aitab_file="/run/archiso/curlspace/${aitab#/run/archiso/bootmnt/}"
- local _aitab_url="${archiso_curl_url}${aitab#/run/archiso/bootmnt/}"
- local _aitab_file="/run/archiso/curlspace/${aitab#/run/archiso/bootmnt/}"
+ _curl_get "${_aitab_url}" "/"
- _curl_get "${_aitab_url}" "${archisobasedir}"
-
- local aitab_img aitab_mnt aitab_arch aitab_sfs_comp aitab_fs_type aitab_fs_size
- while read aitab_img aitab_mnt aitab_arch aitab_sfs_comp aitab_fs_type aitab_fs_size; do
- [[ "${aitab_img#\#}" != "${aitab_img}" ]] && continue
- [[ "${aitab_arch}" != "any" && "${aitab_arch}" != "${arch}" ]] && continue
- if [[ "${aitab_fs_type}" != "none" ]]; then
- _curl_get "${archiso_curl_url}${archisobasedir}/${aitab_arch}/${aitab_img}.fs.sfs" "${archisobasedir}/${aitab_arch}"
- else
- _curl_get "${archiso_curl_url}${archisobasedir}/${aitab_arch}/${aitab_img}.sfs" "${archisobasedir}/${aitab_arch}"
- fi
- done < "${_aitab_file}"
-
- if [[ "${checksum}" == "y" ]]; then
- _curl_get "${archiso_curl_url}${archisobasedir}/checksum.${arch}.md5" "${archisobasedir}"
+ local aitab_img aitab_mnt aitab_arch aitab_sfs_comp aitab_fs_type aitab_fs_size
+ while read aitab_img aitab_mnt aitab_arch aitab_sfs_comp aitab_fs_type aitab_fs_size; do
+ [[ "${aitab_img#\#}" != "${aitab_img}" ]] && continue
+ [[ "${aitab_arch}" != "any" && "${aitab_arch}" != "${arch}" ]] && continue
+ if [[ "${aitab_fs_type}" != "none" ]]; then
+ _curl_get "${archiso_curl_url}${archisobasedir}/${aitab_arch}/${aitab_img}.fs.sfs" "/${aitab_arch}"
+ else
+ _curl_get "${archiso_curl_url}${archisobasedir}/${aitab_arch}/${aitab_img}.sfs" "/${aitab_arch}"
fi
+ done < "${_aitab_file}"
- mkdir -p "/run/archiso/bootmnt"
- mount -o bind /run/archiso/curlspace /run/archiso/bootmnt
- else
- local _dev_loop
+ if [[ "${checksum}" == "y" ]]; then
+ _curl_get "${archiso_curl_url}${archisobasedir}/checksum.${arch}.md5" "/"
+ fi
- _curl_get "${archiso_curl_url}" "/"
+ mkdir -p "/run/archiso/bootmnt"
+ mount -o bind /run/archiso/curlspace /run/archiso/bootmnt
- _dev_loop=$(losetup -f)
- if ! losetup "${_dev_loop}" "/run/archiso/curlspace/${archiso_curl_url##*/}"; then
- echo "ERROR: Setting loopback device '${_dev_loop}'"
- echo " for file '/run/archiso/curlspace/${archiso_curl_url##*/}'"
- echo " Falling back to interactive prompt"
- echo " You can try to fix the problem manually, log out when you are finished"
- launch_interactive_shell
- fi
- fi
archiso_mount_handler ${newroot}
}